#!/bin/bash
# Copyright 2009, 2010, 2014, 2015 Michal Žejdl
# init script for user root; symlink this somewhere to $PATH

confdir=$(dirname $(readlink -f $0))
config=$confdir/defaults.sh
test -f $config || exit
. $config

usage_and_exit ()
{
	echo "Usage: $(basename $0) <start|stop|restart|status>"
	exit
}

test $# -eq 1 || usage_and_exit

command=$1

case "$command" in
#"start" | "stop")
	# login shell is for netldb/snmp/dispatcher.sh - rewrite needed
	# find: cannot get current directory
#	su -c $coredir/$command.sh - $user
"start")
	su -c $coredir/start.sh - $user
	;;
"stop")
	su -c $coredir/stop.sh $user
	;;
"restart")
	su -c $coredir/stop.sh $user
	su -c $coredir/start.sh - $user
	;;
"status")
	tail -n3 $logdir/*.out $logdir/*.err
	;;
*)
	usage_and_exit
esac
