#!/bin/bash
# Copyright 2009, 2010, 2014, 2015 Michal Žejdl
# aktualizuje tabulku uplink

confdir=$(dirname $0)/../core
config=$confdir/defaults.sh
test -f $config || exit
. $config

# čísla portů z poslední procházky po přepínačích,
# na kterých je nejnovější MAC hlavního směrovače (u nás 10.x.1.1)
# čas se bere ten z dotazu, takže odpovídá naposled zachycené MAC adrese v FDB

# co je víc jak den staré není uplink
# (MAC adresa hlavní brány by na přepínačích měla být pořád)
stare=$(($(date +%s) - 24 * 3600))

# 28.11.2011 přišel Michal Zaschke s návrhem:
# misto
# select switch, port, mac, time from fdb left join checked using (mac) where time >= (select min(lastsnmpread) from checked where hasfdb = 'y') and mac in (select mac from arp where ip like '10.%.1.1' and time = (select max(time) from arp arp2 where arp.ip = arp2.ip))
# novy
# select distinct switch, port, fdb.mac, fdb.time from fdb left join checked using (mac) inner join arp on (arp.mac = fdb.mac) inner join (select ip, max(time) time from arp group by ip) t1 on (t1.time = arp.time) and (t1.ip = arp.ip) where fdb.time >= (select min(lastsnmpread) from checked where hasfdb = 'y') and (arp.ip like '10.%.1.1')
#
# takže to vyzkouším s tím, že pro mne je ten select černou skříňkou
#mysql -e "delete from uplink where time < $stare; insert uplink select switch, port, mac, time from fdb left join checked using (mac) where time >= (select min(lastsnmpread) from checked where hasfdb = 'y') and mac in (select mac from arp where ip like '10.%.1.1' and time = (select max(time) from arp arp2 where arp.ip = arp2.ip)) on duplicate key update port = fdb.port, time = fdb.time" $modify_opts
mysql -e "delete from uplink where time < $stare; insert uplink select distinct switch, port, fdb.mac, fdb.time from fdb left join checked using (mac) inner join arp on (arp.mac = fdb.mac) inner join (select ip, max(time) time from arp group by ip) t1 on (t1.time = arp.time) and (t1.ip = arp.ip) where fdb.time >= (select min(lastsnmpread) from checked where hasfdb = 'y') and (arp.ip like '10.%.1.1') on duplicate key update port = fdb.port, time = fdb.time" $modify_opts
