#!/bin/bash
# Michal Žejdl 2008 - 2010, 2012
# hledá MAC na přepínačích
# první subselect (za in) jsou aktivní MAC adresy směrovačů
# druhý subselect (za exist) vykosí dvojice switch/port, jež mají naučený switch
# opravy 27. 8. 2012
#   přídavky do druhého subselect:
#     switch != dns - neodmítnout ty, které na portu uvádějí sami sebe (Compex)
#     time >= unix_timestamp() - 86400 - nebrat v úvahu více než den staré
#       MAC adresy
#   distinct - nechci řešit, proč dotaz vrací více stejných řádků
#     - navíc je to s distinct rychlejší


. /usr/local/etc/mysql_prepinace

if test "$#" -ne "1"; then
  echo -e "\nJako parametr čekám hledanou MAC adresu."
  echo -e "\nnapříklad:\n"
  echo -e "  list.sh 00:16:35:9f:b9:74\n"
  exit
fi

mac=$(echo $1 | arpwatch2normal)
mysql -e "select distinct switch, t1.port, from_unixtime(t1.time) 'time' from fdb t1 left join fdb t2 using(switch) where t1.mac = '$mac' and t2.mac in (select mac from arp where ip like '10.%.1.1' and time = (select max(time) from arp arp2 where arp.ip = arp2.ip) order by ip) and t1.port <> t2.port \
and not exists ( \
  select null from fdb join checked using (mac) \
    where switch = t1.switch and port = t1.port \
      and switch != dns and time >= unix_timestamp() - 86400 \
      and hasfdb = 'y' \
) \
order by time" $mysql_prepinace
