<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang=cs>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="style.css" rel="stylesheet" type="text/css">
<title>IPv4 adresa</title>
</head>
<body>

<?php

if (!isset($_GET["id"])) exit("<p>čekám v URL IPv4 adresu (id)");

$ipv4 = $_GET["id"];

// kontrola validity
if (!preg_match("/^([[:digit:]]{1,3}\.){3}[[:digit:]]{1,3}$/", $ipv4))
	exit("<p>\"$ipv4\" není platná IPv4 adresa");

require "head.html";
echo "<h1>IPv4 adresa $ipv4</h1>\n";

// pro jistotu, kdyby to někdo smazal z conf
$limit = 10;
require "conf.php";
require "functions.php";

$name = try_addr2name($ipv4);
if ($name) {
	echo "<p>\n";
	echo "<h2>DNS jméno $name</h2>";
}

// vytvoření $query_limit
if (isset($_GET["nolimit"])) $query_limit = "";
else $query_limit = " limit ".$limit;

$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit("chyba připojení k databázi");
mysql_select_db($dbname);

// SNMP agent
$result = mysql_query("select agent from snmp4 where address = '$ipv4'");
if ($result)
	if (mysql_num_rows($result)) {
		$snmpagentid = mysql_result($result, 0);
		if (is_numeric($snmpagentid))
			echo "<p>Na adrese sídlí <a href=\"snmp/agent.php?id=",
			     $snmpagentid, "\">SNMP agent</a>.\n";
	}

// ARP

$count = mysql_result(mysql_query(
			"select count(ip) from arp where ip = '$ipv4'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, from_unixtime(time) from arp
			where ip = '$ipv4' order by time desc".$query_limit);

	echo "<h2>tabulka ARP</h2>\n";
	echo "<table border summary=\"tabulka ARP\">\n";
	echo "<tr class=\"green\">",
			 "<th>MAC adresa",
			 "<th>s IPv4 naposledy viděna",
			 "\n";
	while ($row = mysql_fetch_array($result)) {
		echo "<tr class=\"monospace\">",
				 "<td><a href=\"mac.php?id=", $row["mac"], "\">", $row["mac"], "</a>",
				 "<td class=\"center\">", $row["from_unixtime(time)"],
				 "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {
		echo "<p>\n";
		echo "počet řádků: $num_rows,
				 počet <a href=\"ipv4.php?id=$ipv4&nolimit=yes\">všech</a>: ", $count;
	}
}

// test by měl být zbytečný, prošel už nahoře
preg_match("/^([[:digit:]]{1,3}\.){3}/", $ipv4, $subnet24);

echo "<h1>volné IPv4 adresy z rozsahu $subnet24[0]0-255</h1>";

echo "<p>";
echo "Za volné se považují takové adresy, které nebyly více než tři roky vidět na síti a zároveň nemají záznam v DNS.";

$result = mysql_query("select *, from_unixtime(time) from arp upper
		where ip like '$subnet24[0]%' and time =
		(select max(time) from arp where ip = upper.ip)
		order by inet_aton(ip)");

$free_ip4 = false;
$row = mysql_fetch_array($result);

function free_ip4_table_header() {
	global $free_ip4;
	$free_ip4 = true;
	echo "<h2>tabulka volných IPv4 adres</h2>\n";
	echo "<table border summary=\"tabulka volných IPv4 adres\">\n";
	echo "<tr class=\"green\">",
			 "<th>MAC adresa",
			 "<th>IPv4 adresa",
			 "<th>naposledy viděny",
			 "\n";
}

//$debug = true;
for ($i = 0; $i <= 255; $i++) {
	$ip4 = $subnet24[0].$i;
	debug_print($ip4);
	// existuje reverz, jdeme na další
	// jenže pak nepřečtu další řádek, takže takhle ne
	// if (try_addr2name($ip4) != "") continue;
	debug_print("jedeme dál");
	if ($row) {
		debug_print("máme řádek");
		debug_print($row["ip"]);
		if ($row["ip"] == $ip4) {
			// tuhle IPv4 adresu máme v ARP tabulce
			debug_print("máme adresu v tabulce");
			if (($row["time"] < time() - 94672800) and (try_addr2name($ip4) == "")) {
				// je starší tří let a nemá reverz
				debug_print("je starší tří let");
				if (!$free_ip4) free_ip4_table_header();
				echo "<tr class=\"monospace\">",
						 "<td><a href=\"mac.php?id=", $row["mac"], "\">",
						 $row["mac"], "</a>",
						 "<td>", $row["ip"],
						 "<td class=\"center\">", $row["from_unixtime(time)"],
						 "\n";
			}
			// pokusíme se načíst další řádek
			debug_print("pokusíme se načíst další řádek");
			$row = mysql_fetch_array($result);
		} else {
			// zatím máme nižší $i než je další $row
			debug_print("zatím máme nižší $i než je další řádek");
			if (try_addr2name($ip4) == "") {
				if (!$free_ip4) free_ip4_table_header();
				echo "<tr class=\"monospace\"><td><td>$ip4<td>\n";
			}
		}
	} else {
		// už není další $row
		debug_print("už není další řádek");
		if (try_addr2name($ip4) == "") {
			if (!$free_ip4) free_ip4_table_header();
			echo "<tr class=\"monospace\"><td><td>$ip4<td>\n";
		}
	}
}

if ($free_ip4)
	echo "</table>\n";
	else
	echo "<h2>žádné volné adresy</h2>\n";

?>

<?php require "tail.html"?>

</body>
</html>
