<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang=cs>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<link href="style.css" rel="stylesheet" type="text/css">
<title>MAC adresa</title>
</head>
<body>

<?php

if (!isset($_GET["id"])) exit("<p>čekám v URL MAC adresu (id)");

$mac = $_GET["id"];
  
// kontrola validity
if (!preg_match("/^([[:xdigit:]]{2}:){5}[[:xdigit:]]{2}$/", $mac))
	  exit("<p>\"$mac\" není MAC v očekávaném tvaru (01:23:45:67:89:ab)\n");

require "head.html";
echo "<h1>MAC adresa $mac</h1>\n";

// výpis MAC v jiných formátech pro kopírování do CLI
$compressed_mac = str_replace(":", "", $mac);
echo "<p>\n";
echo "Cisco: ",
		 rtrim(preg_replace("/([[:xdigit:]]{4})/", "$1.", $compressed_mac), "."),
		 " | 3Com: ",
		 rtrim(preg_replace("/([[:xdigit:]]{4})/", "$1-", $compressed_mac), "-"),
		 " | ",
		 str_replace(":", "-", $mac),
		 "\n";

// pro jistotu, kdyby to někdo smazal z conf
$limit = 10;
require "conf.php";
require "functions.php";

// vytvoření $query_limit
if (isset($_GET["nolimit"])) $query_limit = "";
else $query_limit = " limit ".$limit;

$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit("chyba připojení k databázi");
mysql_select_db($dbname);

// FDB

$count = mysql_result(mysql_query(
			"select count(mac) from fdb where mac = '$mac'"), 0);

if ($count > 0) {
	echo "<h2>tabulka FDB</h2>\n";
	/*
		 myšlenka je jednoduchá - vybrat takové dvojice switch, port, které mají
		 na sobě hledanou MAC adresu (berou se jen ty sesbírané za poslední hodinu
		 výskytu dané MAC adresy) a z nich tu dvojici, která má na sobě nejméně
		 MAC adres (za stejnou poslední hodinu);
		 přes subselect to bylo nepoužitelně pomalé (žádný index při in), tak je tu
		 kartézský součin fdb s trapným order by count limit 1, protože neumím
		 použít agregační funkci min()
	 */
	// a-á, mysql_query je pouze pro jeden dotaz
	// možná by bylo rychlejší volat to 2x ve where než z PHP pouštět dva dotazy,
	// ale mě se nechce pouštět stejný dotaz 2x
	mysql_query("set @last_hour =
			(select max(time) from fdb where mac = '$mac') - 3600
			");
	$result = mysql_query("
			select switch, port from fdb as first join fdb as second
			using (switch, port)
			where first.mac = '$mac'
			and first.time >= @last_hour and second.time >= @last_hour
			group by switch, port order by count(second.mac) limit 1
			");
	$row = mysql_fetch_array($result);
	echo "<p>\n";
  echo "MAC adresa byla naposledy viděna na portu
		<a href=\"port.php?id=", $row["port"],
		"&amp;switch=", $row["switch"], "\">", $row["port"], "</a>
			přepínače <a href=\"switch.php?id=", $row["switch"], "\">",
		$row["switch"], "</a>.";


	/* asi to vypisovat nebudu
	echo "<p>\n";

	echo "Výskyt MAC adresy na přepínačích:";
	$result = mysql_query("select switch, port, from_unixtime(time) from fdb
		where mac = '$mac' order by time desc".$query_limit);

	echo "<table border summary=\"tabulka výskytů MAC na přepínačích\">\n";
	echo "<tr class=\"green\">",
			 "<th>přepínač",
			 "<th>port",
			 "<th>MAC naposledy viděna",
			 "\n";
	while ($row = mysql_fetch_array($result)) {
	echo "<tr class=\"monospace\">",
			 "<td>", $row["switch"],
			 "<td class=\"right\">", $row["port"],
			 "<td class=\"center\">", $row["from_unixtime(time)"],
			 "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {
		echo "<p>\n";
		echo "počet řádků: $num_rows,
				 počet <a href=\"mac.php?id=$mac&nolimit=yes\">všech</a>: ", $count;
	}
	*/
}

// ARP

$count = mysql_result(mysql_query(
			"select count(mac) from arp where mac = '$mac'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, ip, from_unixtime(time) from arp
			where mac = '$mac' order by time desc".$query_limit);

	echo "<h2>tabulka ARP</h2>\n";
	echo "<table border summary=\"tabulka ARP\">\n";
	echo "<tr class=\"green\">",
			 "<th>IPv4 adresa",
			 "<th>s MAC naposledy viděna",
			 "<th>odpovídající DNS jméno",
			 "\n";
	while ($row = mysql_fetch_array($result)) {
		echo "<tr class=\"monospace\">",
				 "<td><a href=\"ipv4.php?id=", $row["ip"], "\">", $row["ip"], "</a>",
				 "<td class=\"center\">", $row["from_unixtime(time)"],
				 "<td>", try_addr2name($row["ip"]),
				 "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {
		echo "<p>\n";
		echo "počet řádků: $num_rows,
				 počet <a href=\"mac.php?id=$mac&amp;nolimit=yes\">všech</a>: ", $count;
	}
}

// ND

$count = mysql_result(mysql_query(
			"select count(mac) from nd where mac = '$mac'"), 0);

if ($count > 0) {
	$result = mysql_query("select mac, ip6, from_unixtime(time) from nd
		where mac = '$mac' order by time desc".$query_limit);

	echo "<h2>tabulka ND</h2>\n";
	echo "<table border summary=\"tabulka ND\">\n";
	echo "<tr class=\"green\">",
			 "<th>IPv6 adresa",
			 "<th>s MAC naposledy viděna",
			 "<th>odpovídající DNS jméno",
			 "\n";
	while ($row = mysql_fetch_array($result)) {
	echo "<tr class=\"monospace\">",
			 "<td><a href=\"ipv6.php?id=", $row["ip6"], "\">", $row["ip6"], "</a>",
			 "<td class=\"center\">", $row["from_unixtime(time)"],
			 "<td>", try_addr2name($row["ip6"]),
			 "\n";
	}
	echo "</table>\n";

	$num_rows = mysql_num_rows($result);
	if ($count > $num_rows) {
		echo "<p>\n";
		echo "počet řádků: $num_rows,
				 počet <a href=\"mac.php?id=$mac&nolimit=yes\">všech</a>: ", $count;
	}
}

?>

<?php require "tail.html"?>

</body>
</html>
