<?php
$start_time = microtime(true);
$debug = false;
//$debug = true;

// žádná data na vstupu; return to index.php
if (!isset($_GET["search"])) return;
 
$input = $_GET["search"];
/*  if (strlen($input) < 2) {
    echo "zadej alespoň dva znaky";
    exit();
  }
*/

echo "<h1>výsledky</h1>\n";

// chvilku trvalo, než jsem dal pomlčku nakonec
// DEPRECATED as of PHP 5.3.0
//if (!ereg("^[a-zA-Z0-9:._%-]+$", $input)) {
if (!preg_match("/^[a-zA-Z0-9:._%-]+$/", $input)) {
	echo "nečekané znaky na vstupu";
	return;
}

require "conf.php";
require "functions.php";

// rozpoznávání vstupu
if (preg_match("/(_|%)/", $input)) {
	// na vstupu je wildcard, nemá smysl si hrát s reguláry nebo resolvovat
	// všechno bude like, uživatele zklamaly výsledky, takže kouká přímo do db
	// lze alespoň podle určitých znaků omezit počet prohledávaných sloupců
	debug_print("wildcard");
	if (preg_match("/([g-z]|-)/i", $input)) {
		// DNS jméno - jen jeden sloupec
		// na jiné zápisy MAC adresy kašlu, uživatel hledá přímo v tabulkách (-)
		debug_print("DNS jméno");
		//$condition4 = $condition6 = "dns like '$input'";
		$name_condition = "like '$input'";
	} elseif (preg_match("/:/", $input)) {
		// je tam dvojtečka, takže řeším jen sloupce mac nebo ip6
		debug_print("MAC nebo IPv6 adresa");
		//$condition4 = "mac like '$input'";
		//$condition6 = "mac like '$input' or ip6 like '$input'";
		$maca_condition = "like '$input'";
		$ip6a_condition = "like '$input'";
	} elseif (preg_match("/\./", $input)) {
		// tečka je buď IPv4 adresa nebo DNS jméno
		// na jiné zápisy MAC adresy kašlu, uživatel hledá přímo v tabulkách
		if (preg_match("/([[:alpha:]]|-)/", $input)) {
			// DNS jméno - jen jeden sloupec
			// na jiné zápisy MAC adresy kašlu, uživatel hledá přímo v tabulkách (-)
			debug_print("DNS jméno");
			//$condition4 = $condition6 = "dns like '$input'";
			$name_condition = "like '$input'";
		} else {
			debug_print("IPv4 adresa nebo DNS jméno");
			//$condition4 = "ip like '$input' or dns like '$input'";
			//$condition6 = "dns like '$input'";
			$ip4a_condition = "like '$input'";
			$name_condition = "like '$input'";
		}
	} else {
		// konec fantazie, prohledáme všechno
		debug_print("prostě full search, nečekej vysokou rychlost");
		//$condition4 = "mac like '$input' or ip like '$input' or dns like '$input'";
		//$condition6 = "mac like '$input' or ip6 like '$input' or dns like '$input'";
		$maca_condition = "like '$input'";
		$ip4a_condition = "like '$input'";
		$ip6a_condition = "like '$input'";
		$name_condition = "like '$input'";
	}
} else {
	// není wildcard na vstupu, tak si ho připravíme pro některé dotazy
	$like_input = "%$input%";
	debug_print($like_input);
	// tak teď se trochu vyřádíme a pokusíme se zbavit like
	// ještě si vybereme cestu bez či s resolvingem
	if (preg_match("/:/", $input)) {
		// dvojtečka je cesta bez DNS, řešíme MAC nebo IPv6 adresu
		if (preg_match("/^([[:xdigit:]]{2}:){5}[[:xdigit:]]{2}$/", $input)) {
			debug_print("MAC adresa xx:xx:xx:xx:xx:xx");
			//$condition4 = $condition6 = "mac = '$input'";
			$maca_condition = "= '$input'";
		} else {
			// tady se bude řešit arpwatch MAC a IPv6
			debug_print("část MAC, arpwatch nebo IPv6");
			// odtud začínají prasárny volající po předělání
			// je to vlastně nedodělek zkopírovaný z předchozího rozpoznávání
			// takové nehezké a rychlé řešení expanze, když musím brát v úvahu _%
			$modified_input = preg_replace("/(:)/", "$1%", $like_input);
			debug_print($modified_input);
			//$condition4 = "mac like '$modified_input'";
			//$condition6 = "mac like '$modified_input' or ip6 like '$modified_input'";
			$maca_condition = "like '$modified_input'";
			$ip6a_condition = "like '$modified_input'";
		}
	} else {
		// tady už nám podle RFC 1123 hrozí DNS na každém kroku
		debug_print("větev se zátěží DNS");
		// takže nejdřív zkusíme resolving a připravíme přílepky
		//$ip4add = $ip6add = "";
		// vlastní resolving - nejdřív $vstup, podruhé přilepíme doménu
		debug_print("resolving");
		debug_time();
		foreach (array("$input", "$input"."$domain") as $dns) {
			// tady by měla být podpora pro CNAME chains a loops - viz RFC 1034
			if (checkdnsrr($dns, "CNAME")) {
				$records = dns_get_record($dns, DNS_CNAME);
				// tohle vypadá divně, ale pro shortname je checkdnsrr true,
				// ale nic nevrátí; takže přiřazení bude jednou nebo vůbec
				foreach ($records as $record) {
					echo "<p>Jméno $dns ukazuje na ", $record["target"], " (CNAME).\n";
					$dns = $record["target"];
				}
			}
			if (checkdnsrr($dns, "A")) {
				$resolved_ip4a = dns_get_record($dns, DNS_A);
				//foreach ($resolved_ip4a as $record)
				//	$ip4add .= " or ip = '$record[ip]'";
			}
			if (checkdnsrr($dns, "AAAA")) {
				$resolved_ip6a = dns_get_record($dns, DNS_AAAA);
				//foreach ($resolved_ip6a as $record) {
				//	$ip6 = expand_ipv6($record["ipv6"]);
				//	$ip6add .= " or ip6 = '$ip6'";
				//}
			}
		}
		//debug_print($ip4add);
		//debug_print($ip6add);
		debug_time();
		if (preg_match("/^([[:xdigit:]]{2}-){5}[[:xdigit:]]{2}$/", $input)) {
			debug_print("MAC adresa xx-xx-xx-xx-xx-xx nebo DNS jméno");
			$normalized_input = str_replace("-", ":", $input);
			//$condition4 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip4add";
			//$condition6 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip6add";
			$maca_condition = "= '$normalized_input'";
			$name_condition = "like '$like_input'";
		} elseif (preg_match("/^([[:xdigit:]]{4}-){2}[[:xdigit:]]{4}$/", $input)) {
			debug_print("MAC adresa xxxx-xxxx-xxxx nebo DNS jméno");
			$normalized_input = str_replace("-", "", $input);
			$normalized_input = rtrim(
					preg_replace("/([[:xdigit:]]{2})/", "$1:", $normalized_input), ":");
			//$condition4 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip4add";
			//$condition6 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip6add";
			$maca_condition = "= '$normalized_input'";
			$name_condition = "like '$like_input'";
		} elseif (preg_match("/^([[:xdigit:]]{4}\.){2}[[:xdigit:]]{4}$/", $input)) {
			debug_print("MAC adresa xxxx.xxxx.xxxx nebo DNS jméno");
			$normalized_input = str_replace(".", "", $input);
			$normalized_input = rtrim(
					preg_replace("/([[:xdigit:]]{2})/", "$1:", $normalized_input), ":");
			//$condition4 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip4add";
			//$condition6 =
			//	"mac = '$normalized_input' or dns like '$like_input'$ip6add";
				$maca_condition = "= '$normalized_input'";
				$name_condition = "like '$like_input'";
		} elseif
		(preg_match("/^([[:digit:]]{1,3}\.){3}[[:digit:]]{1,3}$/", $input)) {
			debug_print("IPv4 adresa nebo DNS jméno");
			//$condition4 = "ip like '$like_input' or dns like '$like_input'$ip4add";
			//$condition6 = "dns like '$like_input'$ip6add";
			$ip4a_condition = "like '$like_input'";
			$name_condition = "like '$like_input'";
		} elseif (preg_match("/[g-z]/i", $input)) {
			debug_print("DNS jméno");
			//$condition4 = "dns like '$like_input'$ip4add";
			//$condition6 = "dns like '$like_input'$ip6add";
			$name_condition = "like '$like_input'";
		} else {
			debug_print("už nic nerozpoznávám, nutno dodělat poznávání částí");
			debug_print("prostě full search, nečekej vysokou rychlost");
			//$condition4 = "mac like '$like_input' or ip like '$like_input' or
			//	dns like '$like_input'$ip4add";
			//$condition6 = "mac like '$like_input' or ip6 like '$like_input' or
			//	dns like '$like_input'$ip6add";
			$maca_condition = "like '$like_input'";
			$ip4a_condition = "like '$like_input'";
			$ip6a_condition = "like '$like_input'";
			$name_condition = "like '$like_input'";
		}
		// konec části zatížené na DNS
	}
	// konec rozpoznávání, když na vstupu není wildcard
}

debug_time();

$connection = mysql_connect($dbhost, $dbuser, $dbpass);
if (!$connection) exit("chyba připojení k databázi");
mysql_select_db($dbname);

debug_time();


$something_found = false;


// ARP

if (isset($maca_condition) or isset($ip4a_condition) or isset($resolved_ip4a)
		or isset($name_condition)) {
	$where = "";
	$order = "order by time desc";
	if (isset($maca_condition)) {
		$where .= "arp.mac $maca_condition";
	}
	if (isset($ip4a_condition)) {
		if (! empty($where)) $where .= " or ";
		$where .= "arp.ip $ip4a_condition";
	}
	if (isset($resolved_ip4a)) {
		foreach ($resolved_ip4a as $record) {
			if (! empty($where)) $where .= " or ";
			$where .= "arp.ip = '$record[ip]'";
		}
	}
	if (! empty($where)) {
		debug_print($where);
		$query_arp = "select mac, ip, from_unixtime(time) time from arp
			where $where";
	}
	if (isset($name_condition)) {
		$query_rr4 = "select mac, ip, from_unixtime(arp.time) time
			from arp left join rr4 on arp.ip = rr4.address
			where rr4.name $name_condition";
		if (! empty($query_arp))
			$query = "($query_arp) union ($query_rr4) $order";
		else
			$query = "$query_rr4 $order";
	} else
		$query = "$query_arp $order";
	debug_print($query);
	$result = mysql_query($query);
	$num_rows = mysql_num_rows($result);
	if ($num_rows > 0) {
		$something_found = true;
		echo "<h2>tabulka ARP</h2>\n";
		echo "<p>\n";
		echo "počet nalezených záznamů: $num_rows\n";
		echo "<table border summary=\"tabulka ARP\">\n";
		echo "<tr class=\"green\">",
				 "<th>MAC adresa",
				 "<th>IPv4 adresa",
				 "<th>naposledy viděny",
				 "<th>DNS jméno",
				 "\n";
		while ($row = mysql_fetch_array($result)) {
			echo "<tr class=\"monospace\">",
			     "<td><a href=\"mac.php?id=", $row["mac"], "\">",
			     $row["mac"], "</a>",
			     "<td><a href=\"ipv4.php?id=", $row["ip"], "\">",
			     $row["ip"], "</a>",
			     "<td class=\"center\">", $row["time"],
			     "<td>", try_addr2name($row["ip"]),
			     "\n";
		}
		echo "</table>\n";
	}
}

debug_time();


// ND

if (isset($maca_condition) or isset($ip6a_condition) or isset($resolved_ip6a)
		or isset($name_condition)) {
	$where = "";
	$order = "order by time desc";
	if (isset($maca_condition)) {
		$where .= "nd.mac $maca_condition";
	}
	if (isset($ip6a_condition)) {
		if (! empty($where)) $where .= " or ";
		$where .= "nd.ip6 $ip6a_condition";
	}
	if (isset($resolved_ip6a)) {
		foreach ($resolved_ip6a as $record) {
			$ip6a = expand_ipv6($record["ipv6"]);
			if (! empty($where)) $where .= " or ";
			$where .= "nd.ip6 = '$ip6a'";
		}
	}
	if (! empty($where)) {
		debug_print($where);
		$query_nd = "select mac, ip6, from_unixtime(time) time from nd
			where $where";
	}
	if (isset($name_condition)) {
		$query_rr6 = "select mac, ip6, from_unixtime(nd.time) time
			from nd left join rr6 on nd.ip6 = rr6.address
			where rr6.name $name_condition";
		if (! empty($query_nd))
			$query = "($query_nd) union ($query_rr6) $order";
		else
			$query = "$query_rr6 $order";
	} else
		$query = "$query_nd $order";
	debug_print($query);
	$result = mysql_query($query);
	$num_rows = mysql_num_rows($result);
	if ($num_rows > 0) {
		$something_found = true;
		echo "<h2>tabulka ND</h2>\n";
		echo "<p>\n";
		echo "počet nalezených záznamů: $num_rows\n";
		echo "<table border summary=\"tabulka ND\">\n";
		echo "<tr class=\"green\">",
				 "<th>MAC adresa",
				 "<th>IPv6 adresa",
				 "<th>naposledy viděny",
				 "<th>DNS jméno",
				 "\n";
		while ($row = mysql_fetch_array($result)) {
			echo "<tr class=\"monospace\">",
			     "<td><a href=\"mac.php?id=", $row["mac"], "\">",
			     $row["mac"], "</a>",
			     "<td><a href=\"ipv6.php?id=", $row["ip6"], "\">",
			     $row["ip6"], "</a>",
			     "<td class=\"center\">", $row["time"],
			     "<td>", try_addr2name($row["ip6"]),
			     "\n";
		}
		echo "</table>\n";
	}
}


// SNMP
if (isset($like_input))
	// no wildcards on input
	$snmp_input = $like_input;
else
	// a wildcard on input
	$snmp_input = $input;
	
$query = "select id, from_unixtime(time) time, sysDescr, sysObjectID, sysName,
	ifXEntry
	from snmpagent
	where sysName like '$snmp_input' or sysDescr like '$snmp_input'
	order by time desc";

$result = mysql_query($query);
$num_rows = mysql_num_rows($result);
if ($num_rows > 0) {
	$something_found = true;
	echo "<h2>SNMP</h2>\n";
	echo "<p>\n";
	echo "počet nalezených záznamů: $num_rows\n";
	echo "<table border summary=\"SNMP\">\n";
	echo "<tr class=\"green\">",
	     "<th>time",
	     "<th>sysName",
	     "<th>sysDescr",
	     "<th>links",
	     "\n";
	while ($row = mysql_fetch_assoc($result)) {
		echo "<tr class=\"monospace\">";
		echo "<td class=\"center\"><nobr>&nbsp;",
		     $row["time"], "&nbsp;</nobr>";
		echo "<td><nobr>&nbsp;<a href=\"snmp/agent.php?id=", $row["id"],
		     "\">", $row["sysName"], "</a>&nbsp;</nobr>";
		echo "<td>&nbsp;", $row["sysDescr"], "&nbsp;";
		echo "<td><nobr>&nbsp;<a href=\"snmp/mib/ifgraph.php?agent=",
		     $row["id"], "\">if graphs</a>&nbsp;", 
		     "&nbsp;<a href=\"snmp/mib/iftable.php?agent=",
		     $row["id"], "\">ifTable</a>&nbsp;";
		if ($row["ifXEntry"] == "y")
			echo "&nbsp;<a href=\"snmp/mib/ifxtable.php?agent=",
			     $row["id"], "\">ifXTable</a>&nbsp;";
		 if ($organization = sysObjectID2organization(
					 $row["sysObjectID"]))
			 echo "&nbsp;<a href=\"snmp/mib/",
			      $organization, ".php",
			      "?agent=", $row["id"],
			      "\">$organization</a>&nbsp;";
		echo "</nobr>\n";
	}
	echo "</table>\n";
}


// přepínače

if (isset($maca_condition) or isset($ip4a_condition) or isset($resolved_ip4a)
		or isset($name_condition)) {
	$filter = "";
	if (isset($maca_condition)) {
		$filter .= "checked.mac $maca_condition";
	}
	if (isset($ip4a_condition)) {
		if (! empty($filter)) $filter .= " or ";
		$filter .= "arp.ip $ip4a_condition";
	}
	if (isset($resolved_ip4a)) {
		foreach ($resolved_ip4a as $record) {
			if (! empty($filter)) $filter .= " or ";
			$filter .= "arp.ip = '$record[ip]'";
		}
	}
	if (isset($name_condition)) {
		if (! empty($filter)) $filter .= " or ";
		$filter .= "name $name_condition";
	}
	debug_print($filter);
	$query = "select
		mac, ip, from_unixtime(lastsnmpread) lastsnmpread, dns id
		from checked left join arp using (mac)
		left join rr4 on arp.ip = rr4.address
		where dns != '' and hasfdb = 'y'
		and arp.time =
		(select max(sub.time) from arp sub where sub.mac = arp.mac)
		and ($filter) order by lastsnmpread desc";
	debug_print($query);
	$result = mysql_query($query);
	$num_rows = mysql_num_rows($result);
	if ($num_rows > 0) {
		$something_found = true;
		echo "<h2>tabulka přepínačů</h2>\n";
		echo "<p>\n";
		echo "počet nalezených záznamů: $num_rows\n";
		echo "<table border summary=\"tabulka přepínačů\">\n";
		echo "<tr class=\"green\">",
				 "<th>MAC adresa",
				 "<th>IPv4 adresa",
				 "<th>DNS jméno",
				 "<th>naposledy čten přes SNMP",
				 "<th>id -&gt; okolí",
				 "\n";
		while ($row = mysql_fetch_array($result)) {
			echo "<tr class=\"monospace\">",
			     "<td><a href=\"mac.php?id=", $row["mac"], "\">",
			     $row["mac"], "</a>",
			     "<td><a href=\"ipv4.php?id=", $row["ip"], "\">",
			     $row["ip"], "</a>",
			     "<td>", try_addr2name($row["ip"]),
			     "<td class=\"center\">", $row["lastsnmpread"],
			     "<td><a href=\"switch.php?id=", $row["id"], "\">",
			     $row["id"], "</a>",
			     "\n";
		}
		echo "</table>\n";
	}
}

if (! $something_found) echo "<p>nepovedlo se nic nalézt\n";

debug_time();

?>
